import { Subscribable } from 'rx-subject';
export interface ComponentFromStreamFactory<C extends Component<N, any, any>, N> {
    <P = {}, Q = P>(render: (props: Q) => N, operator: Operator<P, Q>): ComponentFromStreamConstructor<C, N>;
    <P = {}, Q = P, A = P>(render: (props: Q) => N, project: Mapper<P, A>, operator: DispatchOperator<A, A, any>, ...operators: DispatchOperator<A, any, any>[]): ComponentFromStreamConstructor<C, N>;
}
export interface ComponentFromStreamOptions {
}
export interface ComponentFromStreamConstructor<C extends Component<N, any, any>, N> {
    new <P = {}, Q = P>(props?: P, context?: any): C & ComponentFromStream<N, P, Q>;
}
export interface ComponentFromStream<N, P = {}, Q = P> extends Component<N, P, PropsState<Q>> {
    componentWillMount(): void;
    componentWillReceiveProps(nextProps: Readonly<P>, nextContext: any): void;
    componentWillUnmount(): void;
    shouldComponentUpdate(props: Readonly<P>, state: Readonly<PropsState<Q>>): boolean;
}
export interface ComponentConstructor<N> {
    new <P = {}, S = {}>(props: P, context?: any): Component<N, P, S>;
}
export interface Component<N, P = {}, S = {}> {
    setState(state: Reducer<S, P> | Partial<S>, cb?: () => void): void;
    render(props?: P, state?: S, context?: any): N | void;
    props: Readonly<P>;
    state: Readonly<S | null>;
    context: any;
}
export interface PropsState<Q> {
    props: Q;
}
export declare type Mapper<P, A = P> = (props: P) => A;
export declare type Operator<I = {}, O = I, U extends Subscribable<I> = Subscribable<I>, V extends Subscribable<O> = Subscribable<O>> = (source$: U) => V;
export declare type DispatchOperator<A = void, I = {}, O = I, Q extends Subscribable<I> = Subscribable<I>, S extends Subscribable<O> = Subscribable<O>> = (source$: Q, dispatch?: StreamableDispatcher<A>, fromESObservable?: <T, O extends Subscribable<T>>(stream: Subscribable<T>) => O, toESObservable?: <T, O extends Subscribable<T>>(stream: O) => Subscribable<T>) => S;
export interface StreamableDispatcher<A, S extends Subscribable<A> = Subscribable<A>> {
    next(val: A): void;
    from<E extends Subscribable<A>>(source$: E): void;
    source$: S;
}
export declare type Reducer<A, V> = (acc: A, val: V) => A;
export { Subscribable };
export default function createComponentFromStreamFactory<C extends Component<N, any, any>, N>(ComponentCtor: new (props: any, context?: any) => C & Component<N, any, any>, fromESObservable: <T, O extends Subscribable<T>>(stream: Subscribable<T>) => O, opts?: Partial<ComponentFromStreamOptions>): ComponentFromStreamFactory<C, N>;
export default function createComponentFromStreamFactory<C extends Component<N, any, any>, N>(ComponentCtor: new (props: any, context?: any) => C & Component<N, any, any>, fromESObservable: <T, O extends Subscribable<T>>(stream: Subscribable<T>) => O, toESObservable: <T, O extends Subscribable<T>>(stream: O) => Subscribable<T>, opts?: Partial<ComponentFromStreamOptions>): ComponentFromStreamFactory<C, N>;
export declare function identity<T>(v: T): T;
