"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
;
const rx_subject_1 = require("rx-subject");
function createComponentFromStreamFactory(ComponentCtor, fromES, toES = identity, opts = {}) {
    return typeof toES !== 'function'
        ? createComponentFromStreamFactory(ComponentCtor, fromES, void 0, toES)
        : function createComponentFromStream(render, project = identity, ...operators) {
            return arguments.length === 2
                ? createComponentFromStream(render, void 0, project)
                : class ComponentFromStreamClass extends ComponentCtor {
                    constructor() {
                        super(...arguments);
                        this.state = {};
                        this._onProps = (props) => this._dispatch(project(props));
                        this._setProps = (props) => this.setState({ props });
                        this._subs = [];
                    }
                    render() {
                        return !this.state.props ? null : render(this.state.props);
                    }
                    componentWillMount() {
                        const q = (this._q = rx_subject_1.default());
                        const source$ = fromES(q.source$);
                        const stack = [];
                        const dispatch = {
                            next: q.sink.next,
                            from: Array.prototype.push.bind(stack),
                            source$
                        };
                        let props$ = source$;
                        for (const operator of operators) {
                            props$ = operator(props$, dispatch, fromES, toES);
                        }
                        this._subs = [toES(props$).subscribe(this._setProps)];
                        for (const dispatch$ of stack) {
                            this._subs.push(toES(dispatch$).subscribe(q.sink));
                        }
                        this._dispatch = dispatch.next;
                        this._onProps(this.props);
                    }
                    componentWillReceiveProps(props) {
                        this._onProps(props);
                    }
                    componentWillUnmount() {
                        this._q.sink.complete();
                        for (const sub of this._subs) {
                            sub.unsubscribe();
                        }
                        delete this._subs;
                        delete this._q;
                    }
                    shouldComponentUpdate(_, state) {
                        return state.props !== this.state.props;
                    }
                };
        };
}
exports.default = createComponentFromStreamFactory;
function identity(v) {
    return v;
}
exports.identity = identity;
